<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Eddie: /builds/eclipse/oniro-core/eddie/linux/communication/include/ResourceDirectory.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Eddie
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_88e6415a3128b404f1102a130772bdb6.html">linux</a></li><li class="navelem"><a class="el" href="dir_9d6112f7740eb6b19e6896a373a5986f.html">communication</a></li><li class="navelem"><a class="el" href="dir_046dfdec3fa9891163197d92ca19a5c8.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">ResourceDirectory.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * SPDX-License-Identifier: Apache-2.0</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * SPDX-FileCopyrightText: Huawei Inc.</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * SPDX-FileCopyrightText: Politecnico Di Milano</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef RESOURCEDIRECTORY_H</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define RESOURCEDIRECTORY_H</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;common.h&quot;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;coap3/coap.h&gt;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="classResourceDirectory.html">   20</a></span>&#160;<span class="keyword">class </span><a class="code" href="classResourceDirectory.html">ResourceDirectory</a> {</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">static</span> <a class="code" href="classThreadSafeMap.html">ThreadSafeMap&lt;std::string, coap_resource_t *&gt;</a> *rd_endpoints;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keyword">static</span> <a class="code" href="classThreadSafeMap.html">ThreadSafeMap&lt;std::string, coap_resource_t *&gt;</a> *rd_endpoints_by_ep_d;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    coap_context_t *context;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordtype">bool</span> quit = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    hnd_post_rd(coap_resource_t *resource, coap_session_t *session, <span class="keyword">const</span> coap_pdu_t *request,</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;                <span class="keyword">const</span> coap_string_t *query, coap_pdu_t *response);</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    hnd_get_lookup_res(coap_resource_t *resource, coap_session_t *session, <span class="keyword">const</span> coap_pdu_t *request,</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;                       <span class="keyword">const</span> coap_string_t *query, coap_pdu_t *response);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    hnd_get_lookup_ep(coap_resource_t *resource, coap_session_t *session, <span class="keyword">const</span> coap_pdu_t *request,</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;                      <span class="keyword">const</span> coap_string_t *query, coap_pdu_t *response);</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    hnd_post_rd_endpoint(coap_resource_t *resource, coap_session_t *session, <span class="keyword">const</span> coap_pdu_t *request,</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;                         <span class="keyword">const</span> coap_string_t *query, coap_pdu_t *response);</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    hnd_delete_rd_endpoint(coap_resource_t *resource, coap_session_t *session, <span class="keyword">const</span> coap_pdu_t *request,</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;                           <span class="keyword">const</span> coap_string_t *query, coap_pdu_t *response);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keyword">static</span> coap_resource_t* create_endpoint(</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keyword">const</span> std::unordered_map&lt;std::string, std::string&gt; &amp;params, </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keyword">const</span> std::string &amp;data</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    );</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keyword">static</span> std::string add_endpoint_to_rd(<span class="keyword">const</span> std::string&amp; ep_d_key,</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;                                    coap_context_t *context,</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;                                    <span class="keyword">const</span> std::unordered_map&lt;std::string, std::string&gt; &amp;params, </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;                                    <span class="keyword">const</span> std::string &amp;data);</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160; </div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keyword">static</span> std::list&lt;std::string&gt;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    endpoints_to_string_list_filtered(std::map&lt;std::string, std::string&gt; filters);</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keyword">static</span> std::list&lt;std::string&gt;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    rd_resources_to_string_list_filtered(std::map&lt;std::string, std::string&gt; filters);</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordtype">int</span> init_server_context();</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    [[nodiscard]] <span class="keywordtype">bool</span> get_quit()<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keywordflow">return</span> quit;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    }</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordtype">void</span> set_quit(<span class="keywordtype">bool</span> val) {</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        quit = val;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    }</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160; </div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160; </div>
<div class="line"><a name="l00094"></a><span class="lineno"><a class="line" href="classResourceDirectory.html#a0576aec7e02d01b0db49a1fde478f419">   94</a></span>&#160;    <span class="keyword">explicit</span> <a class="code" href="classResourceDirectory.html#a0576aec7e02d01b0db49a1fde478f419">ResourceDirectory</a>(<span class="keyword">const</span> std::string&amp; ip, coap_context_t *server_context = <span class="keyword">nullptr</span>);</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div>
<div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="classResourceDirectory.html#afe8e2df620dbb6ab5f262b8eb5ce1192">   99</a></span>&#160;    <a class="code" href="classResourceDirectory.html#afe8e2df620dbb6ab5f262b8eb5ce1192">~ResourceDirectory</a>();</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160; </div>
<div class="line"><a name="l00105"></a><span class="lineno"><a class="line" href="classResourceDirectory.html#a01ed0c86b0af7e3505c924580e0a1ed2">  105</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classResourceDirectory.html#a01ed0c86b0af7e3505c924580e0a1ed2">run</a>();</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;};</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160; </div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="preprocessor">#endif </span></div>
<div class="ttc" id="aclassResourceDirectory_html"><div class="ttname"><a href="classResourceDirectory.html">ResourceDirectory</a></div><div class="ttdef"><b>Definition:</b> ResourceDirectory.h:20</div></div>
<div class="ttc" id="aclassResourceDirectory_html_a01ed0c86b0af7e3505c924580e0a1ed2"><div class="ttname"><a href="classResourceDirectory.html#a01ed0c86b0af7e3505c924580e0a1ed2">ResourceDirectory::run</a></div><div class="ttdeci">int run()</div></div>
<div class="ttc" id="aclassResourceDirectory_html_a0576aec7e02d01b0db49a1fde478f419"><div class="ttname"><a href="classResourceDirectory.html#a0576aec7e02d01b0db49a1fde478f419">ResourceDirectory::ResourceDirectory</a></div><div class="ttdeci">ResourceDirectory(const std::string &amp;ip, coap_context_t *server_context=nullptr)</div><div class="ttdoc">Construct and initialize a new Resource Directory.</div></div>
<div class="ttc" id="aclassResourceDirectory_html_afe8e2df620dbb6ab5f262b8eb5ce1192"><div class="ttname"><a href="classResourceDirectory.html#afe8e2df620dbb6ab5f262b8eb5ce1192">ResourceDirectory::~ResourceDirectory</a></div><div class="ttdeci">~ResourceDirectory()</div></div>
<div class="ttc" id="aclassThreadSafeMap_html"><div class="ttname"><a href="classThreadSafeMap.html">ThreadSafeMap&lt; std::string, coap_resource_t * &gt;</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
